package com.shanghaichengdi.ghjgitem.domain;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.shanghaigeography.annotation.ObjMerge;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.math.BigDecimal;
import java.util.Date;


/**
 * <p>
 * 
 * </p>
 *
 * @author zk
 * @since 2025-03-26
 */
@Data
@EqualsAndHashCode(callSuper = true)
@Accessors(chain = true)
@TableName("ghjg_port_manage.TRANSPORT_SG_BASE_NUMBER")
public class TransportSgBaseNumber extends BaseEntity {

    private static final long serialVersionUID = 1L;

    @TableId("BASE_ID")
    private Long baseId;

    @TableField("BASE_COMPY_ID")
    private Long baseCompyId;

    @TableField("BASE_COMPY_NAME")
    private String baseCompyName;

    @TableField("BASE_BOAT_NAME")
    private String baseBoatName;

    @TableField("BASE_LINE")
    private String baseLine;

    @TableField("BASE_TYPE")
    private String baseType;

    //'年份'
    @TableField("BASE_YEAR")
    private Integer baseYear;

    //'季度'
    @TableField("BASE_QUARTER")
    private Integer baseQuarter;

    @TableField("BASE_BOXES_20F")
    @ObjMerge(isCalculation = true,type = BigDecimal.class,needType = true)
    private BigDecimal baseBoxes20f;

    @TableField("BASE_BOXES_40F")

    @ObjMerge(isCalculation = true,type = BigDecimal.class,needType = true)
    private BigDecimal baseBoxes40f;

    @TableField("BASE_BOXES_45F")
    @ObjMerge(isCalculation = true,type = BigDecimal.class,needType = true)
    private BigDecimal baseBoxes45f;

    @TableField("BASE_BOXES_20E")
    @ObjMerge(isCalculation = true,type = BigDecimal.class,needType = true)
    private BigDecimal baseBoxes20e;

    @TableField("BASE_BOXES_40E")
    @ObjMerge(isCalculation = true,type = BigDecimal.class,needType = true)
    private BigDecimal baseBoxes40e;

    @TableField("BASE_BOXES_45E")
    @ObjMerge(isCalculation = true,type = BigDecimal.class,needType = true)
    private BigDecimal baseBoxes45e;

    @TableField("BASE_HANG_ID")
    private Long baseHangId;

    @TableField("BASE_NOTUP")
    private Integer baseNotup;

    @TableField("IS_DELETED")
    private Integer isDeleted;

    @TableField("COLUMN1")
//    核对四个字段的hashCode
    private String column1;

    @TableField("COLUMN2")
    private String column2;

    @TableField("COLUMN3")
    private String column3;

    @TableField("COLUMN4")
    private String column4;

    @TableField("COLUMN5")
    private String column5;

    @TableField("COLUMN6")
    private String column6;

    @TableField("COLUMN7")
    private String column7;

    @TableField("COLUMN8")
    private String column8;

    @TableField("CREATE_BY")
    private String createBy;

    @TableField("CREATE_TIME")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date createTime;

    @TableField("UPDATE_BY")
    private String updateBy;

    @TableField("UPDATE_TIME")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date updateTime;


}
