package com.shanghaichengdi.ghjgitem.domain;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.util.Date;

/**
 * <p>
 * 上港集团企业信息
 * </p>
 *
 * @author zk
 * @since 2025-03-26
 */
@Data
@EqualsAndHashCode(callSuper = true)
@Accessors(chain = true)
@TableName("ghjg_port_manage.TRANSPORT_SG_DW_NZX_AGENT")
public class TransportSgDwNzxAgent extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * 上港航方企业缩写
     */
    @TableId("NZA_NZXNM")
    private String nzaNzxnm;

    /**
     * 上港航方企业全写
     */
    @TableField("NZA_OUTNAME")
    private String nzaOutname;



    @TableField("IS_DELETED")
    private Integer isDeleted;

    @TableField("COLUMN1")
    private String column1;

    @TableField("COLUMN2")
    private String column2;

    @TableField("COLUMN3")
    private String column3;

    @TableField("COLUMN4")
    private String column4;

    @TableField("COLUMN5")
    private String column5;

    @TableField("COLUMN6")
    private String column6;

    @TableField("COLUMN7")
    private String column7;

    @TableField("COLUMN8")
    private String column8;

    @TableField("CREATE_BY")
    private String createBy;

    @TableField("CREATE_TIME")
    private Date createTime;

    @TableField("UPDATE_BY")
    private String updateBy;

    @TableField("UPDATE_TIME")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date updateTime;


}
