package com.shanghaichengdi.ghjgitem.domain;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.util.Date;


/**
 * <p>
 * 
 * </p>
 *
 * @author zk
 * @since 2025-03-26
 */
@Data
@EqualsAndHashCode(callSuper = true)
@Accessors(chain = true)
@TableName("ghjg_port_manage.TRANSPORT_SG_DW_NZX_BOAT")
public class TransportSgDwNzxBoat extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * PK键
     */
    @TableId("NZX_SCH_PKID")
    private Long nzxSchPkid;

    /**
     * 抽取数据类型domain =,为BL,YSKH,NH
     */
    @TableField("NZX_TYPE")
    private String nzxType;

    /**
     * 靠泊码头
     */
    @TableField("NZX_TERMCD")
    private String nzxTermcd;

    /**
     * 船舶ID 预留
     */
    @TableField("NZX_VSL_ID")
    private String nzxVslId;

    /**
     * 船舶代码
     */
    @TableField("NZX_VSLCD")
    private String nzxVslcd;

    /**
     * 船舶英文名
     */
    @TableField("NZX_VSLENGNM")
    private String nzxVslengnm;

    /**
     * 船舶中文名
     */
    @TableField("NZX_VSLCNNAME")
    private String nzxVslcnname;

    /**
     * 经营人
     */
    @TableField("NZX_AGENT")
    private String nzxAgent;

    /**
     * 航线
     */
    @TableField("NZX_LINE")
    private String nzxLine;

    /**
     * 航次
     */
    @TableField("NZX_VOYAGE")
    private String nzxVoyage;

    /**
     * 装卸标志
     */
    @TableField("NZX_IEFG")
    private String nzxIefg;

    /**
     * 靠泊时间
     */
    @TableField("NZX_BERTHTM")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date nzxBerthtm;

    /**
     * 离泊时间
     */
    @TableField("NZX_LEAVETM")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date nzxLeavetm;

    /**
     * 班期,domain= FLT_SCHDUL
     */
    @TableField("NZX_SCHDATE")
    private String nzxSchdate;

    /**
     * 是否准班
     */
    @TableField("NZX_SCHEDULEFG")
    private String nzxSchedulefg;

    /**
     * 源数据库时间
     */
    @TableField("NZX_SOURCETM")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date nzxSourcetm;

    /**
     * 目的数据库时间
     */
    @TableField("NZX_DESTINATIONTM")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date nzxDestinationtm;

    /**
     * 提交标志
     */
    @TableField("NZX_POSTFG")
    private String nzxPostfg;

    /**
     * 码头标准ID 预留
     */
    @TableField("NZX_TERID")
    private Long nzxTerid;

    /**
     * NZX的船期ID
     */
    @TableField("NZX_VCL_ID")
    private Long nzxVclId;

    /**
     * NZX的靠泊ID
     */
    @TableField("NZX_VBT_ID")
    private Long nzxVbtId;

    /**
     * NZX的航次ID
     */
    @TableField("NZX_VYG_ID")
    private Long nzxVygId;

    /**
     * 完工时间
     */
    @TableField("NZX_AENDTM")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date nzxAendtm;

    /**
     * 开工时间
     */
    @TableField("NZX_ASTARTTM")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date nzxAstarttm;

    /**
     * 数据库修改时间
     */
    @TableField("NZX_UPDATETM")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date nzxUpdatetm;

    /**
     * 修改人
     */
    @TableField("NZX_USER")
    private String nzxUser;

    /**
     * 大的艘次ID
     */
    @TableField("NZX_SBD_ID")
    private Long nzxSbdId;

    /**
     * 删除标记
     */
    @TableField("NZX_DFG")
    private String nzxDfg;

    /**
     * 班轮班期
     */
    @TableField("NZX_SCHBGTM")
    private Date nzxSchbgtm;

    /**
     * Y表示锁定
     */
    @TableField("NZX_NOTUPDATE")
    private String nzxNotupdate;

    /**
     * 锁定时间
     */
    @TableField("NZX_NOTUPDATETM")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date nzxNotupdatetm;

    /**
     * 锁定人
     */
    @TableField("NZX_NOTUPDATEUSER")
    private String nzxNotupdateuser;

    /**
     * 已锁定后更新 0 未更新：1有更新
     */
    @TableField("TRANS_UPDATE")
    private Integer transUpdate;


    @TableField("IS_DELETED")
    private Integer isDeleted;

    @TableField("COLUMN1")
    private String column1;

    @TableField("COLUMN2")
    private String column2;

    @TableField("COLUMN3")
    private String column3;

    @TableField("COLUMN4")
    private String column4;

    @TableField("COLUMN5")
    private String column5;

    @TableField("COLUMN6")
    private String column6;

    @TableField("COLUMN7")
    private String column7;

    @TableField("COLUMN8")
    private String column8;

    @TableField("CREATE_BY")
    private String createBy;

    @TableField("CREATE_TIME")
    private Date createTime;

    @TableField("UPDATE_BY")
    private String updateBy;

    @TableField("UPDATE_TIME")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date updateTime;

}
