package com.shanghaichengdi.ghjgitem.domain;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.math.BigDecimal;
import java.util.Date;

/**
 * <p>
 * 
 * </p>
 *
 * @author zk
 * @since 2025-03-26
 */
@Data
@EqualsAndHashCode(callSuper = true)
@Accessors(chain = true)
@TableName("ghjg_port_manage.TRANSPORT_SG_DW_NZX_CONTAINERS")
public class TransportSgDwNzxContainers extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /**
     * pk键
     */
    @TableId("NZC_PKID")
    private Long nzcPkid;

    /**
     * 船数据对应
     */
    @TableField("NZC_NZX_SCH_PKID")
    private Long nzcNzxSchPkid;

    /**
     * 源数据库箱ID
     */
    @TableField("NZC_CNTRID")
    private Long nzcCntrid;

    /**
     * 箱号
     */
    @TableField("NZC_CNTRNO")
    private String nzcCntrno;

    /**
     * 尺寸，未标准化
     */
    @TableField("NZC_CSIZECD")
    private String nzcCsizecd;

    /**
     * 箱型，未标准化
     */
    @TableField("NZC_CTP_CTYPECD")
    private String nzcCtpCtypecd;

    /**
     * 高度，未标准化
     */
    @TableField("NZC_CHEIGHTCD")
    private String nzcCheightcd;

    /**
     * 重量
     */
    @TableField("NZC_CWEIGHT")
    private BigDecimal nzcCweight;

    /**
     * 危险品，未标准化
     */
    @TableField("NZC_DNGCD")
    private String nzcDngcd;

    /**
     * 持箱人，未标准化
     */
    @TableField("NZC_COWNER")
    private String nzcCowner;

    @TableField("NZC_SOURCETM")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date nzcSourcetm;

    @TableField("NZC_DESTINATIONTM")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date nzcDestinationtm;

    /**
     * 装卸标志
     */
    @TableField("NZC_IEFG")
    private String nzcIefg;

    @TableField("NZC_TERMCD")
    private String nzcTermcd;

    /**
     * 抽取数据类型domain =,为BL,YSKH,NH
     */
    @TableField("NZX_TYPE")
    private String nzxType;

    /**
     * 装货港
     */
    @TableField("NZX_POT_LDPORT")
    private String nzxPotLdport;

    /**
     * 卸货港
     */
    @TableField("NZX_POT_DISPORT")
    private String nzxPotDisport;

    /**
     * 目的港
     */
    @TableField("NZX_POT_DSTPORT")
    private String nzxPotDstport;

    /**
     * 删除标记
     */
    @TableField("NZC_DFG")
    private String nzcDfg;

    /**
     * 空重
     */
    @TableField("NZC_EFFG")
    private String nzcEffg;

    /**
     * 内贸
     */
    @TableField("NZC_NMFG")
    private String nzcNmfg;

    @TableField("NZC_STATUS")
    private String nzcStatus;

    /**
     * 清关
     */
    @TableField("NZC_THROUGHCUSTOM")
    private String nzcThroughcustom;

    /**
     * 中转标记
     */
    @TableField("NZC_TRANS_FLAG")
    private String nzcTransFlag;

    @TableField("CNT_STATUS")
    private String cntStatus;

    /**
     * 删除用户
     */
    @TableField("NZC_DELUSER")
    private String nzcDeluser;

    /**
     * 修改用户
     */
    @TableField("NZC_UPDATEUSER")
    private String nzcUpdateuser;

    /**
     * 港口名
     */
    @TableField("NZC_PORTNM")
    private String nzcPortnm;



    @TableField("IS_DELETED")
    private Integer isDeleted;

    @TableField("COLUMN1")
    private String column1;

    @TableField("COLUMN2")
    private String column2;

    @TableField("COLUMN3")
    private String column3;

    @TableField("COLUMN4")
    private String column4;

    @TableField("COLUMN5")
    private String column5;

    @TableField("COLUMN6")
    private String column6;

    @TableField("COLUMN7")
    private String column7;

    @TableField("COLUMN8")
    private String column8;

    @TableField("CREATE_BY")
    private String createBy;

    @TableField("CREATE_TIME")
    private Date createTime;

    @TableField("UPDATE_BY")
    private String updateBy;

    @TableField("UPDATE_TIME")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date updateTime;
}
