package com.shanghaichengdi.ghjgitem.domain;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.github.jeffreyning.mybatisplus.anno.MppMultiId;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.util.Date;


/**
 * <p>
 * 
 * </p>
 *
 * @author zk
 * @since 2025-03-26
 */
@Data
@EqualsAndHashCode(callSuper = true)
@Accessors(chain = true)
@TableName("ghjg_port_manage.TRANSPORT_SG_SYNC_STATUS")
public class TransportSgSyncStatus extends BaseEntity {

    private static final long serialVersionUID = 1L;

    @TableField("SYNC_ID")
    private Long syncId;

    /**
     * 同步状态：0开始同步  1同步完成
     */
    @TableField("SYNC_STATUS")
    private Integer syncStatus;

    /**
     * 年份
     */
    @MppMultiId
    @TableField("SYNC_YEAR")
    private Integer syncYear;

    /**
     * 季度
     */
    @MppMultiId
    @TableField("SYNC_QUARTER")
    private Integer syncQuarter;

    /**
     * 本季度此次同步船数据总条目数
     */
    @TableField("SYNC_BOAT_TOTAL")
    private Long syncBoatTotal;

    /**
     * 本季度此次同步集装箱总条目数
     */
    @TableField("SYNC_CONTAINERS_TOTAL")
    private Long syncContainersTotal;

    /**
     * 开始同步时间
     */
    @TableField("SYNC_START_TIME")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date syncStartTime;

    /**
     * 同步完成时间
     */
    @TableField("SYNC_END_TIME")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date syncEndTime;

    /**
     * 更新状态：0数据未修改 1存在数据修改
     */
    @TableField("SYNC_UPDATE_STATUS")
    private Integer syncUpdateStatus;

    /**
     * 最新修改时间
     */
    @TableField("SYNC_UPDATE_TIME")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date syncUpdateTime;

    @TableField("IS_DELETED")
    private Integer isDeleted;

    @TableField("COLUMN1")
    private String column1;

    @TableField("COLUMN2")
    private String column2;

    @TableField("COLUMN3")
    private String column3;

    @TableField("COLUMN4")
    private String column4;

    @TableField("COLUMN5")
    private String column5;

    @TableField("COLUMN6")
    private String column6;

    @TableField("COLUMN7")
    private String column7;

    @TableField("COLUMN8")
    private String column8;

    @TableField("CREATE_BY")
    private String createBy;

    @TableField("CREATE_TIME")
    private Date createTime;

    @TableField("UPDATE_BY")
    private String updateBy;

    @TableField("UPDATE_TIME")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date updateTime;


}
